 
 

// Initialise eyes ---------------------------------------------------------
void initEyes(void)
{
	Serial.println("Initialise eye objects");

	// Initialise eye objects based on eyeInfo list in config.h:
	for (uint8_t e = 0; e < NUM_EYES; e++) {
		Serial.print("Create display #"); Serial.println(e);
		eye[e].tft_cs = eyeInfo[e].select;
		eye[e].xang = 0;
		eye[e].yang = 0;
		pinMode(eye[e].tft_cs, OUTPUT);
		digitalWrite(eye[e].tft_cs, LOW);
	}


}

void updateEye2(float xang, float yang)
{
	 
	int16_t sziris = eye[0].irissize;
	int16_t screenX, screenY;
	uint32_t p = 0;
	uint32_t pixels = 0;

	//zero screen
	for (screenY = SCREEN_HEIGHT / 2; screenY < SCREEN_HEIGHT; screenY++)
	{
		for (screenX = 0; screenX < SCREEN_WIDTH; screenX++)
		{

			// Map screen coordinates to sclera coordinates with scaling
				// Use modulo to handle cases where the sclera is smaller than the screen
			int32_t off = screenY * SCREEN_WIDTH + screenX;
			int16_t sph = scleramap[off];
			//if (sph == 0)
			//	continue;
			int32_t nCenter = Center + xang + yang * SCREEN_WIDTH;
			int8_t yoff = sph & 0xff;
			int8_t xoff = (sph & 0xff00) >> 8;
			//iris detection
			int16_t noffy = yoff + yang;
			int16_t noffx = xoff + xang;
			int16_t rad = 70;
			if (abs(noffx) <= 60 && abs(noffy) <= 60)
				rad = irisrad256[icen + (noffy * IRIS1_WIDTH) + noffx] >> 8;
			if (rad < 45)
			{
				int16_t rsin = (irissincos[icen + (noffy * IRIS1_WIDTH) + noffx] & 0xffff0000) >> 16;
				int16_t rcos = (irissincos[icen + (noffy * IRIS1_WIDTH) + noffx] & 0xffff);
				//modify rad for effects
				int16_t szadd = rad;
				if (Catseye)
				{
					if (noffx > -10 && noffx <= 6)
						szadd = 60 - abs(noffx + 2) * 10;
					sziris = 0;
				}

				rad = map(rad, 0, 45, 20 - max(sziris, szadd), 63);
				if (rad < 0) rad = 0;
				noffx = (rad * rcos) >> 10;
				noffy = (rad * rsin) >> 10;
				p = iris1[icen + noffx + noffy * IRIS1_WIDTH];
				if (blink)
				{
					if (yoff > 121 - blinktime)
						p = 0x00;
				}
				else
					if (szadd < 16 && evil)
					{
						uint32_t newcolor = szadd * 2;
						if (newcolor > 31) newcolor = 31;
						p = (32 - newcolor) << 11;
					}
			}
			else
			{
				nCenter += yoff * SCREEN_WIDTH;
				nCenter += xoff;
				if (nCenter > fullscreen)
					nCenter -= fullscreen;
				if (nCenter < 0)
					nCenter += fullscreen;
				p = sclera[nCenter];
			}
			if (blink)
			{
				if (yoff > 121 - blinktime)
					p = 0x00;
			}
			MainScreenBottom[(screenY - SCREEN_HEIGHT / 2) * SCREEN_WIDTH + screenX] = p >> 8 | p << 8;
		}
	}


}

// UPDATE EYE --------------------------------------------------------------
void updateEye(float xang, float yang)
{
	 
	int16_t sziris = eye[0].irissize;
	int16_t screenX, screenY;
	uint32_t p = 0;
	uint32_t pixels = 0;
	uint8_t thisspeed = blinkspeed;
	if (blink && blinkphase == 0)
		blinktime += thisspeed;
	if (blink && blinkphase == 1)
		blinktime -= thisspeed;
	if (blinktime < 0)
	{
		blinktime = 0; blink = false; blinkphase = 0;
	}
	if (blinktime > 122 && blinkphase == 0)
	{
		blinkphase = 1;
		blinktime += blinkspeed << 1;
	}
	//zero screen

	 
	for (screenY = 0; screenY < SCREEN_HEIGHT / 2; screenY++)
	{
		for (screenX = 0; screenX < SCREEN_WIDTH; screenX++)
		{

			// Map screen coordinates to sclera coordinates with scaling
				// Use modulo to handle cases where the sclera is smaller than the screen
			int32_t off = screenY * SCREEN_WIDTH + screenX;
			int16_t sph = scleramap[off];
			//if (sph == 0)
			//	continue;
			int32_t nCenter = Center + xang + yang * SCREEN_WIDTH;
			int8_t yoff = sph & 0xff;
			int8_t xoff = (sph & 0xff00) >> 8;
			//iris detection
			int16_t noffy = yoff + yang;
			int16_t noffx = xoff + xang;
			int16_t rad = 70;
			if (abs(noffx) <= 60 && abs(noffy) <= 60)
				rad = irisrad256[icen + (noffy * IRIS1_WIDTH) + noffx] >> 8;
			if (rad < 45)
			{
				int16_t rsin = (irissincos[icen + (noffy * IRIS1_WIDTH) + noffx] & 0xffff0000) >> 16;
				int16_t rcos = (irissincos[icen + (noffy * IRIS1_WIDTH) + noffx] & 0xffff);
				//modify rad for effects
				int16_t szadd = rad;
				if (Catseye)
				{
					if (noffx > -10 && noffx <= 6)
						szadd = 60 - abs(noffx + 2) * 10;
					sziris = 0;
				}
				int16_t redrad = 20 - max(sziris, szadd);
				rad = map(rad, 0, 45, redrad, 63);
				if (rad < 0) rad = 0;
				noffx = (rad * rcos) >> 10;
				noffy = (rad * rsin) >> 10;
				p = iris1[icen + noffx + noffy * IRIS1_WIDTH];
				if (blink)
				{
					if (yoff < -121 + blinktime)
						p = 0x00;
				}
				else
					if (szadd < 16 && evil)
					{
						uint32_t newcolor = szadd * 2;
						if (newcolor > 31) newcolor = 31;
						p = (32 - newcolor) << 11;
					}
			}
			else
			{
				nCenter += yoff * SCREEN_WIDTH;
				nCenter += xoff;
				if (nCenter > fullscreen)
					nCenter -= fullscreen;
				if (nCenter < 0)
					nCenter += fullscreen;
				p = sclera[nCenter];
				if (blink)
				{
					if (yoff < -121 + blinktime)
						p = 0x00;
				}
			}

			MainScreenTop[screenY * SCREEN_WIDTH + screenX] = p >> 8 | p << 8;
		}
	}


}

void DrawScreen(uint8_t neye, uint8_t nScreen)
{
	static bool init = false;
	if (!init) Serial.println("First Push to screen");
	init = true;

#ifdef USE_DMA
	digitalWrite(eye[neye].tft_cs, LOW);
	tft.startWrite();
	tft.setAddrWindow(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT/2);
	tft.pushPixelsDMA(&MainScreenTop[0], 28800);
	tft.setAddrWindow(0, SCREEN_HEIGHT/2, SCREEN_WIDTH, SCREEN_HEIGHT);
	tft.pushPixelsDMA(&MainScreenBottom[0], 28800);
	tft.endWrite();
	digitalWrite(eye[neye].tft_cs, HIGH);
#endif
	return;
	/*
		digitalWrite(eye[neye].tft_cs, LOW);
		tft.startWrite();
		tft.setAddrWindow(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);

		uint16_t screenX, screenY;
		uint32_t p;
		uint32_t pixels = 0;
		// Now just issue raw 16-bit values for every pixel...

		for (screenY = 0; screenY < SCREEN_HEIGHT; screenY++)
		{
			for (screenX = 0; screenX < SCREEN_WIDTH; screenX++)
			{
				p = MainScreen[screenY * SCREEN_WIDTH + screenX];
				*(&pbuffer[dmaBuf][0] + pixels++) = p >> 8 | p << 8;

				if (pixels >= BUFFER_SIZE)
				{
					yield();
	#ifdef USE_DMA
					tft.pushPixelsDMA(&pbuffer[dmaBuf][0], pixels);
					dmaBuf = !dmaBuf;
	#else
					tft.pushPixels(pbuffer, pixels);
	#endif
					pixels = 0;
				}
			}
		}
			if (pixels)
			{
	#ifdef USE_DMA
				tft.pushPixelsDMA(&pbuffer[dmaBuf][0], pixels);
	#else
				tft.pushPixels(pbuffer, pixels);
	#endif
			}
			tft.endWrite();
			digitalWrite(eye[neye].tft_cs, HIGH);
			*/
}

 
// Process motion for a single frame of left or right eye
void frame(uint16_t iScale) // Iris scale (0-1023)
{
	static bool init = false;
	static int fcnt = 0;
	if (!init) Serial.println("First frame");
	init = true;

	static uint32_t frames = 0; // Used in frame rate calculation
	static uint8_t  eyeIndex = 0; // eye[] array counter
	int16_t         eyeX, eyeY;
	++frames; fcnt++;
	if (fcnt > 128)
	{ // Every 256 frames...
		fcnt = 0;
		float elapsed = (millis() - startTime) / 1000.0;
		if (elapsed) Serial.println((uint16_t)(frames / elapsed)); // Print FPS
	}

	if (++eyeIndex >= NUM_EYES) eyeIndex = 0; // Cycle through eyes, 1 per call
	// Pass all the derived values to the eye-rendering function:
	DrawScreen(0, 0);

}
 
